<?php 

/**
 * MyBB 1.2
 * Copyright  2007 Jesse Labrocca
 *
 * Website: http://www.mybbcentral.com
 *
 */


// The information that shows up on the plugin manager
function contact_info()
{
	return array(
		"name"			=> "Contact Form",
		"description"	=> "Creates a contact form for members and guests.",
		"website"		=> "http://www.mybbcentral.com",
		"author"		=> "Jesse Labrocca",
		"authorsite"	=> "http://www.mybbcentral.com",
		"version"		=> "1.0",
	);
}

// This function runs when the plugin is activated.
function contact_activate()
{
global $db;

    $contact_group = array(
        "gid" => "NULL",
        "name" => "Contact",
        "title" => "Contact",
        "description" => "Add a contact form to your site.",
        "disporder" => "61",
        "isdefault" => "no",
        );
    $db->insert_query("settinggroups", $contact_group);
    $gid = $db->insert_id();


    $contact_1 = array(
        "sid" => "NULL",
        "name" => "contact_email",
        "title" => "Email",
        "description" => "What email address will contact be sent to?",
        "optionscode" => "text",
        "value" => "email@domain.com",
        "disporder" => "1",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $contact_1);

    $contact_2 = array(
        "sid" => "NULL",
        "name" => "contact_guests",
        "title" => "Allow Guest Contact",
        "description" => "Select yes to give guests the ability to use the contact form.",
        "optionscode" => "yesno",
        "value" => "yes",
        "disporder" => "2",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $contact_2);

    $contact_3 = array(
        "sid" => "NULL",
        "name" => "contact_subjects",
        "title" => "Contact Subjects",
        "description" => "These are the possible subject choices please seperate each one with a comma.",
        "optionscode" => "textarea",
        "value" => "اقتراح,شكوى,الإعلان بالمنتدى,استفسار",
        "disporder" => "3",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $contact_3);

    $contact_4 = array(
        "sid" => "NULL",
        "name" => "contact_type",
        "title" => "Contact Type",
        "description" => "How would you prefer to be contacted?",
        "optionscode" => "select
contactpm= PM Contact
contactemail= Email Contact",
        "value" => "contactemail",
        "disporder" => "4",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $contact_4);

    $contact_5 = array(
        "sid" => "NULL",
        "name" => "contact_pmuid",
        "title" => "Contact PM UID",
        "description" => "What is the UID of the member for PMs if you have chosen PM contact above?",
        "optionscode" => "text",
        "value" => "1",
        "disporder" => "5",
        "gid" => intval($gid),
        );
    $db->insert_query("settings", $contact_5);


	$contact_template_1 = array(
		"tid"		=> NULL,
		"title"		=> 'contact',
		"template"	=> '<html>
<head>
<title>{$mybb->settings[bbname]} - {$lang->title}</title>
{$headerinclude}
</head>
<body>
{$header}
{$errors}
<table border="0" cellspacing="{$theme[borderwidth]}" cellpadding="{$theme[tablespace]}" class="tborder">
<tr>
<td class="thead"><strong>{$title}</strong></td>
</tr>
<tr>
<td class="trow1" align="center">
<form action="contact.php" method="post" name="contact" id="contact">
<table border="0" cellspacing="1" width="75%" cellpadding="4">
<tr align="right">
<td>
<fieldset class="trow2">
<legend><strong>{$lang->details}</strong></legend>
<label for="name">{$lang->name}</label><br />
<input class="text" name="name" type="text" id="name" value="{$mybb->user[username]}" size="40" /><br /><label for="emailaddress">{$lang->email}</label><br />
<input class="text" dir="ltr" name="email" type="text" id="emailaddress" value="{$mybb->user[email]}" size="40" /></fieldset>
</td>
</tr>
<tr align="right">
<td><fieldset class="trow2">
<legend><strong>{$lang->subject}</strong></legend>
<select name="subject">
{$subjects}
</select>
<br />
</fieldset>
</td>
	 </tr>
<tr align="right">
<td>
<fieldset class="trow2">
<legend><strong>{$lang->message}</strong></legend>
<textarea name="message" cols="60" rows="12" id="message">{$message}</textarea>
</fieldset>
{$regimage}
</td>
</tr>
</table>
<input class="button" name="send" type="submit" id="send" value="ارسال" />
<input name="whosend" type="hidden" value="{$whosend}" />
<input name="action" type="hidden" value="do_send_contact" />
</form>
</td>
</tr>
</table>
{$footer}
</body>
</html>',
		"sid"		=> "-1",
		"version"	=> "1.0",
		"dateline"	=> "1148741710",
	);

	$db->insert_query("templates", $contact_template_1);
	$db->write_query("UPDATE ".TABLE_PREFIX."settings SET value='contact.php' WHERE name='contactlink'");

    rebuild_settings();

}

// This function runs when the plugin is deactivated.
function contact_deactivate()
{
	global $db, $mybb;

    $query = $db->write_query("SELECT gid FROM ".TABLE_PREFIX."settinggroups WHERE name='Contact'");
    $g = $db->fetch_array($query);
    $db->write_query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE gid='".$g['gid']."'");
    $db->write_query("DELETE FROM ".TABLE_PREFIX."settings WHERE gid='".$g['gid']."'");
	$db->write_query("DELETE FROM ".TABLE_PREFIX."templates WHERE title = 'contact'");
	$db->write_query("UPDATE ".TABLE_PREFIX."settings SET value='mailto:' WHERE name='contactlink'");
    rebuild_settings();
}



?>